//------------------------------------------------------------------
#property copyright "jarikn"
#property link      "Romio.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 14
#property indicator_color1 Orange
#property indicator_color2 DarkGray
#property indicator_color3 Orange
#property indicator_color4 LimeGreen
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT
//
#property indicator_color7 Orange
#property indicator_color8 DarkGray
#property indicator_color9 Orange
#property indicator_color10 LimeGreen
#property indicator_style8 STYLE_DOT
#property indicator_style9 STYLE_DOT
#property indicator_style10 STYLE_DOT
//
#property indicator_color11 Orange
#property indicator_color12 DarkGray
#property indicator_color13 Orange
#property indicator_color14 LimeGreen
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT
//
//
//
//
////////////////////////////////////////
extern int    RsiLength1  = 4;
extern int    RsiPrice1   = PRICE_CLOSE;
extern int    HalfLength1 = 5;
extern int    DevPeriod1  = 100;
extern int    Sise1       = 10;
extern double Deviations1 = 1.0;
extern bool   UseAlert   = true;
extern bool   DrawArrows = true;
////////////////////////////////////
////////////////////////////////////////
extern int    RsiLength2  = 9;
extern int    RsiPrice2   = PRICE_CLOSE;
extern int    HalfLength2 = 5;
extern int    DevPeriod2  = 70;

extern double Deviations2 = 0.8;

////////////////////////////////////
////////////////////////////////////////
extern int    RsiLength3  = 13;
extern int    RsiPrice3   = PRICE_CLOSE;
extern int    HalfLength3 = 5;
extern int    DevPeriod3  = 100;

extern double Deviations3 = 0.7;

////////////////////////////////////
color ColorDn = Crimson;
color ColorUp = DodgerBlue;
int     CodDn = 222;
int     CodUp = 221;

string   Font = "Verdana";

// ti init() if(ObjectFind("100s")<0)GetText(3,"100s","BuySell Pro",LawnGreen,5,5,7);


string PrefixArrow1 = "ArrowsHill1";

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];

double buffer7[];
double buffer8[];
double buffer9[];
double buffer10[];

double buffer11[];
double buffer12[];
double buffer13[];
double buffer14[];

double up[];
double dn[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   HalfLength1=MathMax(HalfLength1,1);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   
   SetIndexBuffer(6,buffer7);
   SetIndexBuffer(7,buffer8);
   SetIndexBuffer(8,buffer9);
   SetIndexBuffer(9,buffer10);
   
   SetIndexBuffer(10,buffer11);
   SetIndexBuffer(11,buffer12);
   SetIndexBuffer(12,buffer13);
   SetIndexBuffer(13,buffer14);

   SetIndexStyle(4,DRAW_ARROW,0,2,Blue);
   SetIndexArrow(4,233);
   SetIndexBuffer(4,up);

   SetIndexStyle(5,DRAW_ARROW,0,2,Red);
   SetIndexArrow(5,234);
   SetIndexBuffer(5,dn);


   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   DellObj(PrefixArrow1);

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,k,counted_bars=IndicatorCounted();
   if(counted_bars<0)
      return(-1);
   if(counted_bars>0)
      counted_bars--;
   int limit=MathMin(Bars-1,Bars-counted_bars+HalfLength1);

   static datetime timeLastAlert = NULL;

   for(i=limit; i>=0; i--)
      buffer1[i] = iRSI(NULL,0,RsiLength1,RsiPrice1,i);
   for(i=limit; i>=0; i--)
   //////////////////////////
   for(i=limit; i>=0; i--)
      buffer7[i] = iRSI(NULL,0,RsiLength2,RsiPrice2,i);
   for(i=limit; i>=0; i--)
   //////////////////////////
   for(i=limit; i>=0; i--)
      buffer11[i] = iRSI(NULL,0,RsiLength3,RsiPrice3,i);
   for(i=limit; i>=0; i--)
   //////////////////////////
     {
      double dev  = iStdDevOnArray(buffer1,0,DevPeriod1,0,MODE_SMA,i);
      double sum  = (HalfLength1+1)*buffer1[i];
      double sumw = (HalfLength1+1);
      for(j=1, k=HalfLength1; j<=HalfLength1; j++, k--)
      
        {
         sum  += k*buffer1[i+j];
         sumw += k;
         if(j<=i)
           {
            sum  += k*buffer1[i-j];
            sumw += k;
           }
        }
      buffer2[i] = sum/sumw;
      buffer3[i] = buffer2[i]+dev*Deviations1;
      buffer4[i] = buffer2[i]-dev*Deviations1;
      //////////////////////*****************************************///////////////////
      double dev2  = iStdDevOnArray(buffer7,0,DevPeriod2,0,MODE_SMA,i);
      double sum2  = (HalfLength2+1)*buffer7[i];
      double sumw2 = (HalfLength2+1);
      for(j=1, k=HalfLength2; j<=HalfLength2; j++, k--)
      
        {
         sum2  += k*buffer7[i+j];
         sumw2 += k;
         if(j<=i)
           {
            sum2  += k*buffer7[i-j];
            sumw2 += k;
           }
        }
      buffer8[i] = sum2/sumw2;
      buffer9[i] = buffer8[i]+dev2*Deviations2;
      buffer10[i] = buffer8[i]-dev2*Deviations2;
      /////////////////////////*********************************////////////////
      double dev3  = iStdDevOnArray(buffer11,0,DevPeriod3,0,MODE_SMA,i);
      double sum3  = (HalfLength3+1)*buffer11[i];
      double sumw3 = (HalfLength3+1);
      for(j=1, k=HalfLength3; j<=HalfLength3; j++, k--)
      ///////////////////////////////////////////////////
        {
         sum3  += k*buffer11[i+j];
         sumw3 += k;
         if(j<=i)
           {
            sum3  += k*buffer11[i-j];
            sumw3 += k;
           }
        }
      buffer12[i] = sum3/sumw3;
      buffer13[i] = buffer12[i]+dev3*Deviations3;
      buffer14[i] = buffer12[i]-dev3*Deviations3;
      /////////////////////////////////////////

      if(buffer1[i] >= buffer3[i] && buffer7[i] >= buffer9[i] && buffer11[i] >= buffer13[i])
        {
         dn[i] = buffer3[i];
         if(DrawArrows)
         
            ArrowDn(Time[i], High[i]);
            
            
            

         if(UseAlert && i == 0 && Time[0] != timeLastAlert)
           {
            Alert(Symbol()+" SELL "+Period());
            timeLastAlert = Time[0];
           }
         
        }

      if(buffer1[i] <= buffer4[i] && buffer7[i] <= buffer10[i] && buffer11[i] <= buffer14[i])
        {
         up[i] = buffer4[i];
         if(DrawArrows)
         
            ArrowUp(Time[i], Low[i]);
            
            

         if(UseAlert && i == 0 && Time[0] != timeLastAlert)
           {
            Alert(Symbol()+" Buy "+Period());
            timeLastAlert = Time[0];
           }
         
        }
        
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ArrowUp(datetime tim,double pr)
  {
   if(ObjectFind(PrefixArrow1+"TextUp"+tim)==-1)
     {
      if(ObjectCreate(PrefixArrow1+"TextUp"+tim,OBJ_TEXT,0,tim,pr-GetDistSdvig()))
         ObjectSetText(PrefixArrow1+"TextUp"+tim,CharToStr(CodUp),Sise1,"WingDings",ColorUp);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ArrowDn(datetime tim,double pr)
  {
   if(ObjectFind(PrefixArrow1+"TextDn"+tim)==-1)
     {
      if(ObjectCreate(PrefixArrow1+"TextDn"+tim,OBJ_TEXT,0,tim,pr+GetDistSdvig()))
         ObjectSetText(PrefixArrow1+"TextDn"+tim,CharToStr(CodDn),Sise1,"WingDings",ColorDn);
     }
  }
extern double TextSdvigMnoj = 2;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetDistSdvig()
  {
   return(iATR(NULL, 0, 100, 1) * TextSdvigMnoj);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DellObj(string dell)
  {
   string name;
   for(int i = ObjectsTotal()-1 ; i >=0 ; i--)
     {
      name = ObjectName(i);
      if(StringFind(name, dell) != EMPTY)
         ObjectDelete(name);
     }
  }
//+------------------------------------------------------------------+
